void startup(void){
  int i, val=0;

  /* Startup Function */
  ccnet_crate_reset();
  check_lam();  // for clean interrupt

  /* Dummy LAM definition */
  crate_define_lam(LAMN);

  /* Create ccnet command frame */
  ccnetstartup();

  /* Create user command frame */
  usr_ccnet_gen_init(USR_CMDLEN);
  for(i=0;i<SCRLEN;i++){
    usr_ccnet_gen_cc(CLKSCR, i, 0, val);
  }

  control_mod(0, COINN, 0, 9);
  control_mod(0, ADC1, 0, 9);
  control_mod(0, ADC2, 0, 9);
  control_mod(0, TDC1, 0, 9);
  control_mod(0, FILLIPS, 0, 9);
  control_mod(0, LUPOGG, 0, 9);

  val = 1500; // Interrupt Delay 1500*20ns = 30us
  write_data(0,LUPOGG,3,21,val);

  val = 0;   // Delay for CH0  0*20ns=0ns 
  write_data(0,LUPOGG,0,21,val);

  val = 50; // Width for CH0 10*20ns=200ns
  write_data(0,LUPOGG,0,20,val);

  

  /* Set trigger mode */
  ccnet_trig();                   // Interrupt by CC/NET front panel
  ccnet_pulsemode();              // Define pulse mode
  ccnet_pulse();                  // Output pulse from CC/NET front panel
}
