void map(void){

  univ_init_window(LUPOADDR, REGSIZE, A32, LUPOMAPN);
  univ_init_window(TDC1ADDR, REGSIZE, A32, TDC1MAPN);
  univ_init_window(TDC2ADDR, REGSIZE, A32, TDC2MAPN);
  univ_init_window(TDC3ADDR, REGSIZE, A32, TDC3MAPN);
  univ_init_window(ADCBASE, ADCMAPSIZ, A32, ADCMAPN);
  univ_init_window(SCRADDR, REGSIZE, A32, SCRMAPN);
  //univ_init_window(MCSTADDR, REGSIZE, A32, MCSTMAPN);

  univ_init_dma(TDC1ADDR, DMASIZE, TDC1MAPN);
  univ_init_dma(TDC2ADDR, DMASIZE, TDC2MAPN);
  univ_init_dma(TDC3ADDR, DMASIZE, TDC3MAPN);

  //univ_init_dma(MCSTADDR, DMASIZE, MCSTMAPN);
  //univ_init_dma(ADCBASE|ADC1OFF, DMASIZE, ADC1N);
  //univ_init_dma(ADCBASE|ADC2OFF, DMASIZE, ADC2N);
  //univ_init_dma(ADCBASE|ADC3OFF, DMASIZE, ADC3N);
  //univ_init_dma(ADCBASE|ADC4OFF, DMASIZE, ADC4N);
  //univ_init_dma(ADCBASE|ADC5OFF, DMASIZE, ADC5N);
  //univ_init_dma(ADCBASE|ADC6OFF, DMASIZE, ADC6N);
}


void startup(void){
  short val;
  /* Startup Function */

  vme_define_intlevel(INTLEVEL);

  // Trigger Activation
  //val = 0x01;  // 0x03=Enable Trig. and VETO
  //val = 0x00;  // 0x00=Disable Trig. and VETO
  //vlupodm_trgact_map(LUPOMAPN, val);

  scrinit();

  v785_multi_map_clear(ADC1OFF, ADCMAPN);
  v785_multi_map_clear(ADC2OFF, ADCMAPN);
  v785_multi_map_clear(ADC3OFF, ADCMAPN);
  v785_multi_map_clear(ADC4OFF, ADCMAPN);
  v785_multi_map_clear(ADC5OFF, ADCMAPN);
  v785_multi_map_clear(ADC6OFF, ADCMAPN);
  v785_multi_map_clear(ADC7OFF, ADCMAPN);

  //val = 0x8;
  //vlupodm_trgconf_map(LUPOMAPN, val);

  // Output Configuration
  val = 0x01;  // 1=Output Reg.
  vlupodm_outconf0_map(LUPOMAPN, val);
  val = 0x01;  // 1=Output Reg.
  vlupodm_outconf1_map(LUPOMAPN, val);
  val = 0x02;  // 0x02=Ungated Trigger
  //val = 0x10;  // 0x10=Clock 1KHz
  vlupodm_outconf2_map(LUPOMAPN, val);
  val = 0x04;  // 0x04=Gated Trigger
  //val = 0x10;  // 0x10=Clock 1KHz
  vlupodm_outconf3_map(LUPOMAPN, val);

  // Interrupt delay 20ns step
  //val = 1000; // 20us; 
  //vlupodm_intdelay_map(LUPOMAPN, val);

  val = 600; // 12us; exp2010 koba 
  vlupodm_intdelay_map(LUPOMAPN, val);

  //v785_map_clear(MCSTMAPN);
  //v1190_map_clear(TDC1MAPN);
  //v1190_map_clear(TDC2MAPN);

  vlupodm_clearall_map(LUPOMAPN);

  // Trigger Activation
  val = 0x01;  // 0x03=Enable Trig. and VETO
  //val = 0x03;  // 0x03=Enable Trig. and VETO
  vlupodm_trgact_map(LUPOMAPN, val);

  //vlupodm_enable_interrupt_map(LUPOMAPN);
  vlupodm_pulse_map(LUPOMAPN, OPCLEAR);
  vlupodm_pulse_map(LUPOMAPN, OPBUSYCL);
  vlupodm_clear_map(LUPOMAPN);

}
